from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.site import SiteBlock, SiteBlockInactive, SiteBlockProvisioning


class SiteInactive(SubscriptionModel, is_base=True):
    site: SiteBlockInactive


class SiteProvisioning(SiteInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    site: SiteBlockProvisioning


class Site(SiteProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    site: SiteBlock
